<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: cpp_filrouge_iscj_allemann/include/Spell/ISpell.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7b4dd9274471389300495e9c763ca813.html">cpp_filrouge_iscj_allemann</a></li><li class="navelem"><a class="el" href="dir_e5b3fe71963387781ba01d2a56ee1874.html">include</a></li><li class="navelem"><a class="el" href="dir_393455b0c9ecb55f7340e0c0c06882c2.html">Spell</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ISpell.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_i_spell_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">// #include &quot;..\Character\CharacterClass.hpp&quot; //Do not put here, else circular reference !  https://openclassrooms.com/forum/sujet/class-was-not-declared-in-this-scope-21430</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span>He_Arc::RPG</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;{</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="comment">//use this instead for declar the class and avoid circular ref</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">class </span>CharacterClass;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html">   36</a></span>&#160;    <span class="keyword">class </span><a class="code" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html">ISpell</a></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    {</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html#ad086e14e97ce72f3465ab223302b7c45">   43</a></span>&#160;        <span class="keywordtype">string</span> m_name{<span class="stringliteral">&quot;Unnamed spell&quot;</span>};</div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html#a9ee92c3e820f19c863cf1f25adb028e1">   48</a></span>&#160;        <span class="keywordtype">int</span> m_range{0};</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html">ISpell</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html#a0a084940e3f8c49ffaf795d56789fe81">   57</a></span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">string</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html#a0a084940e3f8c49ffaf795d56789fe81">GetName</a>() <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html#a50ff278f804165aa8efc8a81ae8dfc7c">   63</a></span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html#a50ff278f804165aa8efc8a81ae8dfc7c">GetRange</a>() <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    };</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;} <span class="comment">// namespace He_Arc::RPG</span></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_i_spell_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_i_spell.html">He_Arc::RPG::ISpell</a></div><div class="ttdoc">Interface class, for the different spell/skill who can be rise by characters.</div><div class="ttdef"><b>Definition:</b> ISpell.hpp:37</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_i_spell_html_a0a084940e3f8c49ffaf795d56789fe81"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_i_spell.html#a0a084940e3f8c49ffaf795d56789fe81">He_Arc::RPG::ISpell::GetName</a></div><div class="ttdeci">virtual string GetName() const =0</div><div class="ttdoc">Get the name of the object.</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_i_spell_html_a50ff278f804165aa8efc8a81ae8dfc7c"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_i_spell.html#a50ff278f804165aa8efc8a81ae8dfc7c">He_Arc::RPG::ISpell::GetRange</a></div><div class="ttdeci">virtual int GetRange() const =0</div><div class="ttdoc">Range (number of lane from the user of spell) where the spell can be used.</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
